//Software exemplo para utilização sa biblioteca SPIFFS
//Essa biblioteca gera e gerencia um arquivo TXT
//Pode ser utilizado para salvar parâmetros ou configurações
//Também pode ser utilizado para data logger

//Nesse exemplo será gerado um data logger para 4 valores
//Esses valores serão atribuidos de maneira aleatória
//Os valores serão gravados a cada intervalo de tempo configurado
//Teremos a opção de criar, apagar, inserir valores e ler o arquivo

//inclusão da biblioteca SPIFFS
#include "SPIFFS.h"

//Armazena o estado de inicialização da SPFFIS
bool    SPIFFS_present = false;

//Variáveis para teste
int16_t Var_1 = 0;                  //Valor 1 para log
int16_t Var_2 = 0;                  //Valor 2 para log
int16_t Var_3 = 0;                  //Valor 3 para log
int16_t Var_4 = 0;                  //Valor 4 para log
unsigned long TMR_Old = 0;          //Contador de tempo para gravação
unsigned long TMR_Write = 10000;    //Tempo em ms definido entre as gravações
unsigned long TMR_Delay = 0;        //Delay para deixar a impressão dos valores na leitura mais lento
String Registro;                    //String que recebe o texto a ser gravado no arquivo
char inChar;                        //Variável que recebe os comandos da serial

//Inclusão das funções de controle
#include "Func_Ctrl.h"

void setup() {
  //Inicializa a serial USB
  Serial.begin(115200);
  
  //Inicializa e verifica a biblioteca
  if (!SPIFFS.begin(true)) {
    Serial.println("SPIFFS falha na inicialização...");
    SPIFFS_present = false;
  }
  else
  {
    Serial.println(F("SPIFFS inicializada... acesso ao arquivo habilitado..."));
    SPIFFS_present = true;
  }

}

void loop() {

  //Atribuição de valores às variáveis
  Var_1++;
  Var_2--;
  Var_3 = Var_1 - Var_2;
  Var_4 = Var_1 * 3;

  //Salva os valores no arquivo a cada intervalo de tempo definido
  if (millis() > (TMR_Old + TMR_Write)){
    Registro = String(Var_1) + "," + String(Var_2) + "," + String(Var_3) + "," + String(Var_4);
    REGISTRAR_LOGS("/Teste1.txt", Registro);
    TMR_Old = millis();
  }

  if (Serial.available() > 0) {
    //Leitura do comando enviado via serial
    inChar = (char)Serial.read();

    //Executa a leitura do arquivo (imprime na serial)
    if (inChar == 'R'){
      LER_LOG("/Teste1.txt");
    }

    //Apaga o arquivo
    if (inChar == 'D'){
      DELETAR_LOGS("/Teste1.txt");
    }

    //Cria o arquivo
    if (inChar == 'C'){
      CRIAR_LOG("/Teste1.txt");
    }

    //Apaga a variável para não executar um comando mais de uma vez
    inChar = ' ';

  }

}
